CtA_Hawk = LibStub("AceAddon-3.0"):NewAddon("CtA_Hawk", "AceEvent-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("CtA_Hawk", true)
local LSM = LibStub("LibSharedMedia-3.0")

LSM:Register("sound", "War Drums", [[Sound\Event Sounds\Event_wardrum_ogre.wav]])

local UPDATEPERIOD, elapsed = 5, 0

CtA_Hawk.display = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("CtA Hawk", {type = "data source", label=L["CtA"], text = L["..."]})

CtA_Hawk.updateframe = CreateFrame("frame")

local shortageStatus = {}
CtA_Hawk.shortageStatus = shortageStatus
local Status = {
	Unknown = 0,
	Rare = LFG_ROLE_SHORTAGE_RARE,
	Uncommon = LFG_ROLE_SHORTAGE_UNCOMMON,
	Plentiful = LFG_ROLE_SHORTAGE_PLENTIFUL,
}

local StatusName = {
	[Status.Unknown] = L["Unknown"],
	[Status.Rare] = L["Rare"],
	[Status.Uncommon] = L["Uncommon"],
	[Status.Plentiful] = L["Plentiful"],
}

local shortageStatusCounts = {
	Tank = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
	Healer = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
	DPS = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
}

local shortageColors = {
	[Status.Unknown] = "|cFF808080",
	[Status.Rare] = "|cFFFF0000",
	[Status.Uncommon] = "|cFFFFFF00",
	[Status.Plentiful] = "|cFFCCCCCC",
}

local availableRoles = {}

local roleIcons = {
	Tank = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:0:19:20:39|t",
	Healer = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:20:39:0:19|t",
	DPS = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:20:39:20:39|t",
}

function CtA_Hawk:OnInitialize()

	availableRoles["Tank"], availableRoles["Healer"], availableRoles["DPS"] = UnitGetAvailableRoles("player")

	self.options = {
		name = L["CtA Hawk: Options"],
		type = "group",
		args = {
			settings = {
				name = "settings",
				type = "group",
				args = {
					addon_enabled = {
						type = "toggle",
						name = L["Enabled"],
						desc = L["Check to enable monitoring and notification of Call to Arms."],
						set = function(info,val)
							if val then
								CtA_Hawk:Enable()
							else
								CtA_Hawk:Disable()
							end
							CtA_Hawk.db.profile.enabled = val
						end,
						get = function(info) return CtA_Hawk:IsEnabled() end,
						order = 0,
					},
					spacer1 = {
						type = "description", 
						name = "\n",
						order = 1,
					},
					general = {
						type = "group",
						name = L["General"],
						order = 2,
						args = {
							ldbDisplay = {
								type = "group",
								name = L["LDB Display Options"],
								inline = true,
								order = 1,
								args = {
									shortLabel = {
										type = "toggle",
										name = L["Short Label"],
										desc = L["Display \"CtA\" on the LDB text instead of \"Call To Arms\""],
										order = 1,
										set = function(info, val)
											CtA_Hawk.db.profile.shortLabel = val
											CtA_Hawk:RefreshLDB()
										end,
										get = function()
											return CtA_Hawk.db.profile.shortLabel
										end,
									},
									shortText = {
										type = "toggle",
										name = L["Short Text"],
										desc = L["Display \"T\", \"H\" and \"D\" on the LDB text instead of \"Tank\", \"Healer\" and \"DPS\""],
										order = 2,
										set = function(info, val)
											CtA_Hawk.db.profile.shortText = val
											CtA_Hawk:RefreshLDB()
										end,
										get = function()
											return CtA_Hawk.db.profile.shortText
										end,
									},
								},
							},
							spacer1 = {
								type = "description",
								name = "\n",
								order = 2,
							},
							autoqueue = {
								type = "select",
								name = L["Auto-Queue"],
								desc = L["Automatically enter the queue for the following role when CtA begins for it."],
								order = 3,
								width = "full",
								values = {
									Tank = L["Tank"],
									Healer = L["Healer"],
									DPS = L["DPS"],
								},
								set = function (_, val)
									CtA_Hawk.autoQueue = val
								end,
								get = function ()
									return CtA_Hawk.autoQueue
								end,
							},
						},
					},
					queues = {
						type = "group",
						name = L["Dungeon Groups"],
						desc = L["Select which dungeon queues you wish to watch for Calls to Arms."],
						order = 3,
						args = {},
					},
					Tank = {
						type = "group",
						name = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:0:19:20:39|t"..L["Tank"],
						order = 4,
						args = {
							monitor = {
								type = "select",
								name = L["Monitor Tank Role"],
								desc = L["Under what circumstances should this role be monitored?"],
								values = {
									[1] = L["Never"],
									[2] = L["Always"],
									[3] = L["If selected in LFD"],
									[4] = L["If I can fill the role"],
								},
								style = "dropdown",
								order = 1,
								set = function(info, val)
									CtA_Hawk.db.profile.Tank.monitor = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Tank.monitor
								end,
							},
							alert = {
								type = "select",
								name = "|cFFFFCC00"..L["Alert When"],
								values = {
									[1] = L["Rare"],
									[2] = L["Uncommon"],
									[3] = L["Either"],
								},
								order = 2,
								set = function(info, val)
									CtA_Hawk.db.profile.Tank.alert = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Tank.alert
								end,
							},
							text = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Text Alert"],
								desc = L["Display message on screen when CtA becomes available for this role."],
								descStyle = "inline",
								order = 4,
								set = function(info, val)
									CtA_Hawk.db.profile.Tank.textNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Tank.textNotify
								end,
							},
							chat = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Chat Alert"],
								desc = L["Display message in chat window when CtA becomes available for this role."],
								descStyle = "inline",
								order = 5,
								set = function(info, val)
									CtA_Hawk.db.profile.Tank.chatNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Tank.chatNotify
								end,
							},
							soundFile = {
								type = "select",
								dialogControl = "LSM30_Sound",
								name = L["Audible Alert"],
								desc = L["Select a sound file to be played when CtA becomes available for this role."],
								values = LSM:HashTable("sound"),
								get = function()
									return current
								end,
								set = function(self,key)
									current = key
								end,
								order = 7,
								set = function(info, val)
									CtA_Hawk.db.profile.Tank.soundFile = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Tank.soundFile
								end,
							},
						},
					},
					Healer = {
						type = "group",
						name = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:20:39:0:19|t"..L["Healer"],
						order = 4,
						args = {
							monitor = {
								type = "select",
								name = L["Monitor Healer Role"],
								desc = L["Under what circumstances should this role be monitored?"],
								values = {
									[1] = L["Never"],
									[2] = L["Always"],
									[3] = L["If selected in LFD"],
									[4] = L["If I can fill the role"],
								},
								style = "dropdown",
								order = 1,
								set = function(info, val)
									CtA_Hawk.db.profile.Healer.monitor = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Healer.monitor
								end,
							},
							alert = {
								type = "select",
								name = "|cFFFFCC00"..L["Alert When"],
								values = {
									[1] = L["Rare"],
									[2] = L["Uncommon"],
									[3] = L["Either"],
								},
								order = 2,
								set = function(info, val)
									CtA_Hawk.db.profile.Healer.alert = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Healer.alert
								end,
							},
							text = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Text Alert"],
								desc = L["Display message on screen when CtA becomes available for this role."],
								descStyle = "inline",
								order = 4,
								set = function(info, val)
									CtA_Hawk.db.profile.Healer.textNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Healer.textNotify
								end,
							},
							chat = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Chat Alert"],
								desc = L["Display message in chat window when CtA becomes available for this role."],
								descStyle = "inline",
								order = 5,
								set = function(info, val)
									CtA_Hawk.db.profile.Healer.chatNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Healer.chatNotify
								end,
							},
							soundFile = {
								type = "select",
								dialogControl = "LSM30_Sound",
								name = L["Audible Alert"],
								desc = L["Select a sound file to be played when CtA becomes available for this role."],
								values = LSM:HashTable("sound"),
								get = function()
									return current
								end,
								set = function(self,key)
									current = key
								end,
								order = 7,
								set = function(info, val)
									CtA_Hawk.db.profile.Healer.soundFile = val
								end,
								get = function()
									return CtA_Hawk.db.profile.Healer.soundFile
								end,
							},
						},
					},
					DPS = {
						type = "group",
						name = "|TInterface\\LFGFrame\\UI-LFG-ICON-PORTRAITROLES:20:20:0:0:64:64:20:39:20:39|t"..L["DPS"],
						order = 4,
						args = {
							monitor = {
								type = "select",
								name = L["Monitor DPS Role"],
								desc = L["Under what circumstances should this role be monitored?"],
								values = {
									[1] = L["Never"],
									[2] = L["Always"],
									[3] = L["If selected in LFD"],
									[4] = L["If I can fill the role"],
								},
								style = "dropdown",
								order = 1,
								set = function(info, val)
									CtA_Hawk.db.profile.DPS.monitor = val
								end,
								get = function()
									return CtA_Hawk.db.profile.DPS.monitor
								end,
							},
							alert = {
								type = "select",
								name = "|cFFFFCC00"..L["Alert When"],
								values = {
									[1] = L["Rare"],
									[2] = L["Uncommon"],
									[3] = L["Either"],
								},
								order = 2,
								set = function(info, val)
									CtA_Hawk.db.profile.DPS.alert = val
								end,
								get = function()
									return CtA_Hawk.db.profile.DPS.alert
								end,
							},
							text = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Text Alert"],
								desc = L["Display message on screen when CtA becomes available for this role."],
								descStyle = "inline",
								order = 4,
								set = function(info, val)
									CtA_Hawk.db.profile.DPS.textNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.DPS.textNotify
								end,
							},
							chat = {
								type = "toggle",
								name = "|cFFFFCC00"..L["Chat Alert"],
								desc = L["Display message in chat window when CtA becomes available for this role."],
								descStyle = "inline",
								order = 5,
								set = function(info, val)
									CtA_Hawk.db.profile.DPS.chatNotify = val
								end,
								get = function()
									return CtA_Hawk.db.profile.DPS.chatNotify
								end,
							},
							soundFile = {
								type = "select",
								dialogControl = "LSM30_Sound",
								name = L["Audible Alert"],
								desc = L["Select a sound file to be played when CtA becomes available for this role."],
								values = AceGUIWidgetLSMlists.sound,
								get = function()
									return current
								end,
								set = function(self,key)
									current = key
								end,
								order = 7,
								set = function(info, val)
									CtA_Hawk.db.profile.DPS.soundFile = val
								end,
								get = function()
									return CtA_Hawk.db.profile.DPS.soundFile
								end,
							},
						},
					},
				},
			},
		},
	}
	
	self.defaults = {
		profile = {
			enabled = true,
			shortLabel = false,
			shortText = false,
			queues = {
				["auto"] = true,
			},
			Tank = {
				monitor = 3,
				alert = 1,
				textNotify = true,
				chatNotify = true,
				soundFile = "War Drums",
			},
			Healer = {
				monitor = 3,
				alert = 1,
				textNotify = true,
				chatNotify = true,
				soundFile = "War Drums",
			},
			DPS = {
				monitor = 3,
				alert = 1,
				textNotify = true,
				chatNotify = true,
 				soundFile = "War Drums",
			},
		}
	}
	
	self.db = LibStub("AceDB-3.0"):New("CtA_HawkOptions",self.defaults,"Default")
	
	self.options.args.profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	LibStub("AceConfig-3.0"):RegisterOptionsTable("CtA_Hawk", self.options)
	
	self.settingsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CtA_Hawk", L["CtA Hawk"], nil, "settings")  
	self.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("CtA_Hawk", L["Profiles"], L["CtA Hawk"], "profiles")
	
	if not self.db.profile.enabled then self:Disable() end

	self.updateframe:SetScript("OnUpdate",CtA_Hawk.UpdateFrameUpdate)
	
end

function CtA_Hawk:OnLFGInitialize()
	local t = {
		["auto"] = {
			type = "toggle",
			name = "|cFFFFCC00"..L["Auto-recommend"],
			set = function(info, val)
				CtA_Hawk.db.profile.queues = {} 
				CtA_Hawk.db.profile.queues["auto"] = val
				CtA_Hawk.db.profile.queues[tostring(GetRandomDungeonBestChoice())] = true
			end,
			get = function()
				return CtA_Hawk.db.profile.queues.auto
			end,
			order = 0,
		}
	}
	
	for i=1, GetNumRandomDungeons() do
		local id, name = GetLFGRandomDungeonInfo(i)
		shortageStatus[id] = {
			Name = name,
			Status = { Tank = 0, Healer = 0, DPS = 0 },
		}
		t[tostring(id)] = {
			type = "toggle",
			name = strsub(name, 8),
			disabled = function() return CtA_Hawk.db.profile.queues.auto end, 
			set = function(info, val)
				CtA_Hawk.db.profile.queues[id] = val
			end,
			get = function()
				return (CtA_Hawk.db.profile.queues[id] and not CtA_Hawk.db.profile.queues.auto) or (CtA_Hawk.db.profile.queues.auto and GetRandomDungeonBestChoice() == id)
			end,
			order = 10000 - id,
		}
	end
	self.options.args.settings.args.queues.args = t
	self.LFGInitialized = true 
	RequestLFDPlayerLockInfo()
	CtA_Hawk:RefreshLDB()
end

function CtA_Hawk.UpdateFrameUpdate(self, elap)

	if not CtA_Hawk.LFGInitialized then
		elapsed = elapsed + elap
		if elapsed < .5 then return end
		elapsed = 0
		if GetNumRandomDungeons() > 0 then 
			CtA_Hawk:OnLFGInitialize()
		end
		return
	end

	if not CtA_Hawk:IsEnabled() then return end

	elapsed = elapsed + elap
	if elapsed < UPDATEPERIOD then return end
	elapsed = 0

	RequestLFDPlayerLockInfo()

end

function CtA_Hawk:OnEnable()
	self:RegisterEvent("LFG_UPDATE_RANDOM_INFO")
	if self.LFGInitialized then RequestLFDPlayerLockInfo() end
end

function CtA_Hawk:OnDisable()
	CtA_Hawk.display.text = "|cFF808080"..L["Disabled"]
end

local function IsMonitored(role)
	if CtA_Hawk.db.profile[role].monitor == 1 then --NEVER
		return false
	elseif CtA_Hawk.db.profile[role].monitor == 2 then --ALWAYS
		return true
	elseif CtA_Hawk.db.profile[role].monitor == 3 then --SELECTED
		local LFGRoles = {}
		_, LFGRoles.Tank, LFGRoles.Healer, LFGRoles.DPS = GetLFGRoles()
		return LFGRoles[role]
	elseif CtA_Hawk.db.profile[role].monitor == 4 then --AUTO
		return availableRoles(role)
	end
end

function CtA_Hawk:LFG_UPDATE_RANDOM_INFO ()

	if not self.LFGInitialized then return end
	
	shortageStatusCounts = {
		Tank = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
		Healer = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
		DPS = { [Status.Unknown] = 0, [Status.Rare] = 0, [Status.Uncommon] = 0, [Status.Plentiful] = 0 },
	}

	for i=1, GetNumRandomDungeons() do
		local dungeonGroup, dungeonName = GetLFGRandomDungeonInfo(i);

		local dungeonData = {
			Name = dungeonName,
			Monitored = (self.db.profile.queues.auto and dungeonGroup == GetRandomDungeonBestChoice()) or (self.db.profile.queues[dungeonGroup] and not self.db.profile.queues.auto),
			Status = { Tank = 0, Healer = 0, DPS = 0},
			Reward = {},
		}

		for statusID=1, LFG_ROLE_NUM_SHORTAGE_TYPES do
			
			local eligible, forTank, forHealer, forDPS, itemCount, money, xp = GetLFGRoleShortageRewards(dungeonGroup, statusID);
			
			if forTank then dungeonData.Status.Tank = statusID end
			if forHealer then dungeonData.Status.Healer = statusID end
			if forDPS then dungeonData.Status.DPS = statusID end
			
			dungeonData.Eligible = eligible
			dungeonData.Reward[statusID] = {Item = itemCount, Money = money, XP = xp}
			
		end
		
		if dungeonData.Monitored then
			shortageStatusCounts.Tank[dungeonData.Status.Tank] = shortageStatusCounts.Tank[dungeonData.Status.Tank] + 1
			shortageStatusCounts.Healer[dungeonData.Status.Healer] = shortageStatusCounts.Healer[dungeonData.Status.Healer] + 1
			shortageStatusCounts.DPS[dungeonData.Status.DPS] = shortageStatusCounts.DPS[dungeonData.Status.DPS] + 1
			if shortageStatus[dungeonGroup].Status.Tank ~= dungeonData.Status.Tank then self:ProcessShortageStatusChange(dungeonGroup, "Tank", dungeonData.Status.Tank) end
			if shortageStatus[dungeonGroup].Status.Healer ~= dungeonData.Status.Healer then self:ProcessShortageStatusChange(dungeonGroup, "Healer", dungeonData.Status.Healer) end
			if shortageStatus[dungeonGroup].Status.DPS ~= dungeonData.Status.DPS then self:ProcessShortageStatusChange(dungeonGroup, "DPS", dungeonData.Status.DPS) end
		end
		
		shortageStatus[dungeonGroup] = dungeonData

	end
	
end

function CtA_Hawk:ProcessShortageStatusChange(dungeonGroup, role, newStatus)

	CtA_Hawk:RefreshLDB()

	if not IsMonitored(role) then return end
	if newStatus == Status.Rare and bit.band(CtA_Hawk.db.profile[role].alert, 1) == 0 then return end
	if newStatus == Status.Uncommon and bit.band(CtA_Hawk.db.profile[role].alert, 2) == 0 then return end
	if newStatus == Status.Plentiful then return end
	
	if CtA_Hawk.db.profile[role].textNotify then
		RaidNotice_AddMessage( RaidBossEmoteFrame, L["Call To Arms: "]..roleIcons[role]..shortageColors[newStatus]..L[role].."|r - "..shortageStatus[dungeonGroup].Name, ChatTypeInfo["RAID_BOSS_EMOTE"] )
	end
	
	if CtA_Hawk.db.profile[role].chatNotify then
		ChatFrame1:AddMessage( L["Call To Arms: "]..roleIcons[role]..shortageColors[newStatus]..L[role].."|r - "..shortageStatus[dungeonGroup].Name, 1, .8, 0, 1 )
	end
	
	if CtA_Hawk.db.profile[role].soundFile ~= "" and CtA_Hawk.db.profile[role].soundFile ~= "None" then
		PlaySoundFile(LSM:Fetch("sound",CtA_Hawk.db.profile[role].soundFile),"Master")
	end
	
	if CtA_Hawk.autoQueue == role then
		CtA_Hawk:EnterQueue(dungeonGroup, role)
	end
end

function CtA_Hawk:EnterQueue(dungeonGroup, role)
	local LFGRoles = {}
	LFGRoles.Leader, LFGRoles.Tank, LFGRoles.Healer, LFGRoles.DPS = GetLFGRoles()
	if role then
		LFGRoles.Tank, LFGRoles.Healer, LFGRoles.DPS = false, false, false
		LFGRoles[role] = true
		CtA_Hawk.autoQueue = nil
	end
	SetLFGRoles(LFGRoles.Leader, LFGRoles.Tank, LFGRoles.Healer, LFGRoles.DPS)
	if dungeonGroup then 
		SetLFGDungeon(dungeonGroup)
	elseif LFDQueueFrame.type then
		SetLFGDungeon(LFDQueueFrame.type)
	else
		SetLFGDungeon(GetRandomDungeonBestChoice())
	end
	JoinLFG()
end

function CtA_Hawk:RefreshLDB()
	self.display.label = self.db.profile.shortLabel and L["CtA"] or L["Call To Arms"] 
	self.display.icon = "Interface\\ICONS\\Achievement_Arena_2v2_3"

	local text = ""
	if bit.band(1, self.db.profile.Tank.alert) == 1 and shortageStatusCounts.Tank[Status.Rare] > 0 then
		text = text..shortageColors[Status.Rare]..(self.db.profile.shortText and L["T"] or L["Tank"])..(shortageStatusCounts.Tank[Status.Rare] > 1 and " ("..shortageStatusCounts.Tank[Status.Rare]..") " or " ")
	elseif bit.band(2, self.db.profile.Tank.alert) == 2 and shortageStatusCounts.Tank[Status.Uncommon] > 0 then
		text = text..shortageColors[Status.Uncommon]..(self.db.profile.shortText and L["T"] or L["Tank"])..(shortageStatusCounts.Tank[Status.Uncommon] > 1 and " ("..shortageStatusCounts.Tank[Status.Uncommon]..") " or " ")
	end
	if bit.band(1, self.db.profile.Healer.alert) == 1 and shortageStatusCounts.Healer[Status.Rare] > 0 then
		text = text..shortageColors[Status.Rare]..(self.db.profile.shortText and L["H"] or L["Healer"])..(shortageStatusCounts.Healer[Status.Rare] > 1 and " ("..shortageStatusCounts.Healer[Status.Rare]..") " or " ")
	elseif bit.band(2, self.db.profile.Healer.alert) == 2 and shortageStatusCounts.Healer[Status.Uncommon] > 0 then
		text = text..shortageColors[Status.Uncommon]..(self.db.profile.shortText and L["H"] or L["Healer"])..(shortageStatusCounts.Healer[Status.Uncommon] > 1 and " ("..shortageStatusCounts.Healer[Status.Uncommon]..") " or " ")
	end
	if bit.band(1, self.db.profile.DPS.alert) == 1 and shortageStatusCounts.DPS[Status.Rare] > 0 then
		text = text..shortageColors[Status.Rare]..(self.db.profile.shortText and L["D"] or L["DPS"])..(shortageStatusCounts.DPS[Status.Rare] > 1 and " ("..shortageStatusCounts.DPS[Status.Rare]..") " or " ")
	elseif bit.band(2, self.db.profile.DPS.alert) == 2 and shortageStatusCounts.DPS[Status.Uncommon] > 0 then
		text = text..shortageColors[Status.Uncommon]..(self.db.profile.shortText and L["D"] or L["DPS"])..(shortageStatusCounts.DPS[Status.Uncommon] > 1 and " ("..shortageStatusCounts.DPS[Status.Uncommon]..") " or " ")
	end
	self.display.text = (text ~= "") and text or "|cFF808080"..L["N/A"]

end

function CtA_Hawk.display:OnEnter()
	local tooltip = LibStub("LibQTip-1.0"):Acquire("CtA_HawkTooltip", 6, "LEFT", "CENTER", "CENTER", "CENTER", "CENTER", "CENTER")
	local checkmark = "|TInterface\\BUTTONS\\UI-CheckBox-Check:20:20|t"
	local goldicon = "|TInterface\\MONEYFRAME\\UI-GoldIcon:16:16|t"
	self.tooltip = tooltip 
	tooltip:AddHeader(L["Dungeon Group"], "M","R", L["Tank"], L["Healer"], L["DPS"])
	for i=GetNumRandomDungeons(), 1, -1 do
		local dungeonGroup = GetLFGRandomDungeonInfo(i)
		local dungeonData = shortageStatus[dungeonGroup]
		tooltip:AddLine(
			(dungeonData.Eligible and "|cFFFFCC00" or "|cFFCCCCCC")..dungeonData.Name, 
			(dungeonData.Monitored and checkmark or ""), 
			(dungeonData.Reward[Status.Rare].Item + dungeonData.Reward[Status.Rare].Money + dungeonData.Reward[Status.Rare].XP > 0 and goldicon or ""),
			shortageColors[dungeonData.Status.Tank]..StatusName[dungeonData.Status.Tank], 
			shortageColors[dungeonData.Status.Healer]..StatusName[dungeonData.Status.Healer], 
			shortageColors[dungeonData.Status.DPS]..StatusName[dungeonData.Status.DPS].." "
		)
	end
	tooltip:SmartAnchorTo(self)
	tooltip:Show()
end

function CtA_Hawk.display:OnLeave()
   -- Release the tooltip
   LibStub("LibQTip-1.0"):Release(self.tooltip)
   self.tooltip = nil
end

function CtA_Hawk.display:OnClick(button)
	if IsMouseButtonDown(button) then return end
	if button == "RightButton" then
		InterfaceOptionsFrame_OpenToCategory(CtA_Hawk.settingsFrame)
	end
	if button == "LeftButton" then
		if IsControlKeyDown() then
			CtA_Hawk:EnterQueue()
		else
			ToggleLFDParentFrame()
		end
	end
end